/*
 * points.cpp
 *
 *  Created on: 20/05/2017
 *      Author: rescue
 */

#include <crosbot/geometry/points.hpp>

#include <istream>
#include <sstream>
#include <string>

namespace crosbot {

// TODO: Fix parsing to match toString()
Point2D Point2D::parse(std::string str) {
    double x, y;
    if (sscanf(str.c_str(), "(%lf,%lf)", &x,&y) == 2) {
    } else if (sscanf(str.c_str(), "(%lf %lf)", &x,&y) == 2) {
    } else if (sscanf(str.c_str(), "(%lf, %lf)", &x,&y) == 2) {
    } else if (sscanf(str.c_str(), "( %lf %lf )", &x,&y) == 2) {
    } else if (sscanf(str.c_str(), "( %lf, %lf )", &x,&y) == 2) {
    } else if (sscanf(str.c_str(), "( %lf , %lf )", &x,&y) == 2) {
    } else {
        return Point2D();
    }

    return Point2D(x,y);
}

Point3D Point3D::parse(std::string str) {
    // Check for starting "point" string
    if (str.find("Point") != std::string::npos) {
        // Parse Point
        int start = str.find_first_of('(');
        int end = str.find_first_of(')');
        std::string pointStr = str.substr(start+1, end);

        // Parse Quaternion
        std::istringstream iss(pointStr);
        double x, y, z;
        iss >> x;
        iss.get();
        iss >> y;
        iss.get();
        iss >> z;

        return Point3D(x, y, z);
    } else {
        // Use legacy parsing
        double x, y, z;
        if (sscanf(str.c_str(), "(%lf,%lf,%lf)", &x,&y,&z) == 3) {
        } else if (sscanf(str.c_str(), "(%lf %lf %lf)", &x,&y,&z) == 3) {
        } else if (sscanf(str.c_str(), "(%lf, %lf, %lf)", &x,&y,&z) == 3) {
        } else if (sscanf(str.c_str(), "( %lf %lf %lf )", &x,&y,&z) == 3) {
        } else if (sscanf(str.c_str(), "( %lf, %lf, %lf )", &x,&y,&z) == 3) {
        } else if (sscanf(str.c_str(), "( %lf , %lf , %lf )", &x,&y,&z) == 3) {
        } else {
            return Point3D();
        }

        return Point3D(x,y,z);
    }

    return Point3D();
}

} // namespace crosbot

